class
	CE_POINTER_POINTER [G]

inherit
	CE_POINTER [CE_POINTER [G]]
		redefine
			make,
			make_shared,
			make_shared_with_count,
			make_cast
		end
	INTERNAL
		rename
			is_equal as is_equal_from_any
		undefine
			is_equal_from_any
		end

create
	make,
	make_shared,
	make_shared_with_count,
	make_cast

feature {NONE}

	make
		do
			init_element_info
			Precursor
		end

	make_shared (a_c_pointer: POINTER)
		do
			init_element_info
			Precursor (a_c_pointer)
		end

	make_shared_with_count (a_c_pointer: POINTER; a_count: INTEGER_32)
		do
			init_element_info
			Precursor (a_c_pointer, a_count)
		end

	make_cast (a_other: CE_POINTER [ANY])
		do
			init_element_info
			Precursor (a_other)
		end

feature {ANY}

	element_size: INTEGER_32
		do
			Result := {PLATFORM}.Pointer_bytes
		end

feature {ANY}

	i_th alias "[]" (a_index: INTEGER_32): CE_POINTER [G] assign set_i_th
		do
			Result ?= new_instance_of (element_type_id)
			Result.make_shared (c_read (c_pointer, a_index * {PLATFORM}.Pointer_bytes))
		end

	set_i_th (a_item: CE_POINTER [G]; a_index: INTEGER_32)
		do
			c_write (c_pointer, a_index * {PLATFORM}.Pointer_bytes, a_item.c_pointer)
		end

feature {ANY}

	plus alias "+" (i: INTEGER_32): CE_POINTER_POINTER [G]
		local
			l_count: INTEGER_32
		do
			if byte_count = {INTEGER_32}.Max_value then
				l_count := count
			else
				l_count := count - i
			end
			create Result.make_shared_with_count (c_pointer + (i * {PLATFORM}.Pointer_bytes), l_count)
		end

feature {ANY} -- c utilities

	c_read (a_c_pointer: POINTER; a_offset: INTEGER_32): POINTER
		external
			"C inline"
		alias
			"return *(EIF_POINTER *)($a_c_pointer + $a_offset);"
		end

	c_write (a_c_pointer: POINTER; a_offset: INTEGER_32; a_value: POINTER)
		external
			"C inline"
		alias
			"*(EIF_POINTER *)($a_c_pointer + $a_offset) = $a_value;"
		end

feature {NONE}

	element_info_cache: SPECIAL [INTEGER_32]
		once ("PROCESS")
			create Result.make_filled (-1, 10_000)
		end

	init_element_info
		do
			element_type_id := element_info_cache[({G}).type_id]
			if element_type_id = -1 then
				element_type_id := (create {CE_UTILITIES}).effective_type_id (True, {G})
				element_info_cache[({G}).type_id] := element_type_id
			end
		end

	element_type_id: INTEGER_32

end
