class
	S_STDIO_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	vfprintf (a_s: CE_POINTER [SD_IO_FILE]; a_format: CE_POINTER [INTEGER_8]; a_arg: CE_VA_LIST): INTEGER_32
		do
			Result := c_vfprintf (a_s.c_pointer, a_format.c_pointer, a_arg.c_pointer)
		end

	c_vfprintf (a_s: POINTER; a_format: POINTER; a_arg: POINTER): INTEGER_32
		external
			"C inline use <sdl_mixer.h>"
		alias
			"return vfprintf($a_s, $a_format, $a_arg);"
		end

	getc_unlocked (a_fp: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_getc_unlocked (a_fp.c_pointer)
		end

	c_getc_unlocked (a_fp: POINTER): INTEGER_32
		external
			"C inline use <sdl_mixer.h>"
		alias
			"return getc_unlocked($a_fp);"
		end

	putc_unlocked (a_c: INTEGER_32; a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_putc_unlocked (a_c, a_stream.c_pointer)
		end

	c_putc_unlocked (a_c: INTEGER_32; a_stream: POINTER): INTEGER_32
		external
			"C inline use <sdl_mixer.h>"
		alias
			"return putc_unlocked($a_c, $a_stream);"
		end

	getdelim (a_lineptr: CE_POINTER [CE_POINTER [INTEGER_8]]; a_n: CE_POINTER [NATURAL_32]; a_delimiter: INTEGER_32; a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := c_getdelim (a_lineptr.c_pointer, a_n.c_pointer, a_delimiter, a_stream.c_pointer)
		end

	c_getdelim (a_lineptr: POINTER; a_n: POINTER; a_delimiter: INTEGER_32; a_stream: POINTER): INTEGER_32
		external
			"C inline use <sdl_mixer.h>"
		alias
			"return __getdelim($a_lineptr, $a_n, $a_delimiter, $a_stream);"
		end

	vprintf (a_fmt: CE_POINTER [INTEGER_8]; a_arg: CE_VA_LIST): INTEGER_32
		local
			l_arg: CE_VA_LIST
		do
			l_arg := a_arg.twin
			Result := (vfprintf ((create {CE_CLASS_POINTER [SD_IO_FILE]}.make_shared (Io.output.file_pointer)), a_fmt, l_arg.twin))
		end

	getline (a_lineptr: CE_POINTER [CE_POINTER [INTEGER_8]]; a_n: CE_POINTER [NATURAL_32]; a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := (getdelim (a_lineptr, a_n, ('%N').code, a_stream))
		end

	feof_unlocked (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := (((a_stream.item.flags).bit_and (16)) /= 0).to_integer
		end

	ferror_unlocked (a_stream: CE_POINTER [SD_IO_FILE]): INTEGER_32
		do
			Result := (((a_stream.item.flags).bit_and (32)) /= 0).to_integer
		end

end
