class
	S_STRING_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	memset (a_s: CE_POINTER [ANY]; a_c: INTEGER_32; a_n: NATURAL_32): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared (c_memset (a_s.c_pointer, a_c, a_n))
		end

	c_memset (a_s: POINTER; a_c: INTEGER_32; a_n: NATURAL_32): POINTER
		external
			"C inline use <sdl_mixer.h>"
		alias
			"return (EIF_POINTER)memset($a_s, $a_c, $a_n);"
		end

	strcspn_c1 (a_s: CE_POINTER [INTEGER_8]; a_reject: INTEGER_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_result := (0).to_natural_32
				when 1 then -- loop condition:
					if False then
						l_pos := -1 + 4 -- skip loop
					end
				when 2 then -- loop body:
						if (a_s[l_result.to_integer_32]).to_integer_32 /= 0 then
							if (a_s[l_result.to_integer_32]).to_integer_32 = a_reject then
								l_pos := -1 + 4 -- break
							end
						else
							l_pos := -1 + 4 -- break
						end
				when 3 then
						l_result := l_result + 1
						l_pos := -1 + 1 -- back to loop condition
				when 4 then -- loop done
					Result := l_result
					l_pos := -1 + -1 -- return
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	strcspn_c2 (a_s: CE_POINTER [INTEGER_8]; a_reject1, a_reject2: INTEGER_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_result := (0).to_natural_32
				when 1 then -- loop condition:
					if False then
						l_pos := -1 + 4 -- skip loop
					end
				when 2 then -- loop body:
						if (a_s[l_result.to_integer_32]).to_integer_32 /= 0 then
							if (a_s[l_result.to_integer_32]).to_integer_32 /= a_reject1 then
								if (a_s[l_result.to_integer_32]).to_integer_32 = a_reject2 then
									l_pos := -1 + 4 -- break
								end
							else
								l_pos := -1 + 4 -- break
							end
						else
							l_pos := -1 + 4 -- break
						end
				when 3 then
						l_result := l_result + 1
						l_pos := -1 + 1 -- back to loop condition
				when 4 then -- loop done
					Result := l_result
					l_pos := -1 + -1 -- return
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	strcspn_c3 (a_s: CE_POINTER [INTEGER_8]; a_reject1, a_reject2, a_reject3: INTEGER_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_result := (0).to_natural_32
				when 1 then -- loop condition:
					if False then
						l_pos := -1 + 4 -- skip loop
					end
				when 2 then -- loop body:
						if (a_s[l_result.to_integer_32]).to_integer_32 /= 0 then
							if (a_s[l_result.to_integer_32]).to_integer_32 /= a_reject1 then
								if (a_s[l_result.to_integer_32]).to_integer_32 /= a_reject2 then
									if (a_s[l_result.to_integer_32]).to_integer_32 = a_reject3 then
										l_pos := -1 + 4 -- break
									end
								else
									l_pos := -1 + 4 -- break
								end
							else
								l_pos := -1 + 4 -- break
							end
						else
							l_pos := -1 + 4 -- break
						end
				when 3 then
						l_result := l_result + 1
						l_pos := -1 + 1 -- back to loop condition
				when 4 then -- loop done
					Result := l_result
					l_pos := -1 + -1 -- return
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	strspn_c1 (a_s: CE_POINTER [INTEGER_8]; a_accept: INTEGER_32): NATURAL_32
		local
			l_result: NATURAL_32
		do
			l_result := (0).to_natural_32
			from
			until
				(a_s[l_result.to_integer_32]).to_integer_32 /= a_accept
			loop
				l_result := l_result + 1
			end
			Result := l_result
		end

	strspn_c2 (a_s: CE_POINTER [INTEGER_8]; a_accept1, a_accept2: INTEGER_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_result := (0).to_natural_32
				when 1 then -- loop condition:
					if False then
						l_pos := -1 + 4 -- skip loop
					end
				when 2 then -- loop body:
						if (a_s[l_result.to_integer_32]).to_integer_32 /= a_accept1 then
							if (a_s[l_result.to_integer_32]).to_integer_32 /= a_accept2 then
								l_pos := -1 + 4 -- break
							end
						end
				when 3 then
						l_result := l_result + 1
						l_pos := -1 + 1 -- back to loop condition
				when 4 then -- loop done
					Result := l_result
					l_pos := -1 + -1 -- return
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	strspn_c3 (a_s: CE_POINTER [INTEGER_8]; a_accept1, a_accept2, a_accept3: INTEGER_32): NATURAL_32
		local
			l_result: NATURAL_32
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_result := (0).to_natural_32
				when 1 then -- loop condition:
					if False then
						l_pos := -1 + 4 -- skip loop
					end
				when 2 then -- loop body:
						if (a_s[l_result.to_integer_32]).to_integer_32 /= a_accept1 then
							if (a_s[l_result.to_integer_32]).to_integer_32 /= a_accept2 then
								if (a_s[l_result.to_integer_32]).to_integer_32 /= a_accept3 then
									l_pos := -1 + 4 -- break
								end
							end
						end
				when 3 then
						l_result := l_result + 1
						l_pos := -1 + 1 -- back to loop condition
				when 4 then -- loop done
					Result := l_result
					l_pos := -1 + -1 -- return
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	strpbrk_c2 (a_s: CE_POINTER [INTEGER_8]; a_accept1, a_accept2: INTEGER_32): CE_POINTER [INTEGER_8]
		local
			l_s: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s := a_s
				when 1 then -- loop condition:
					if False then
						l_pos := -1 + 4 -- skip loop
					end
				when 2 then -- loop body:
						if (l_s[0]).to_integer_32 /= 0 then
							if (l_s[0]).to_integer_32 /= a_accept1 then
								if (l_s[0]).to_integer_32 = a_accept2 then
									l_pos := -1 + 4 -- break
								end
							else
								l_pos := -1 + 4 -- break
							end
						else
							l_pos := -1 + 4 -- break
						end
				when 3 then
						l_s := l_s + 1
						l_pos := -1 + 1 -- back to loop condition
				when 4 then -- loop done
					if (l_s[0]).to_integer_32 = 0 then
						l_tmp := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					else
						l_tmp := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer + ((l_s.c_pointer.to_integer_32).to_natural_32).to_integer_32)
					end
					Result := l_tmp
					l_pos := -1 + -1 -- return
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	strpbrk_c3 (a_s: CE_POINTER [INTEGER_8]; a_accept1, a_accept2, a_accept3: INTEGER_32): CE_POINTER [INTEGER_8]
		local
			l_s: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s := a_s
				when 1 then -- loop condition:
					if False then
						l_pos := -1 + 4 -- skip loop
					end
				when 2 then -- loop body:
						if (l_s[0]).to_integer_32 /= 0 then
							if (l_s[0]).to_integer_32 /= a_accept1 then
								if (l_s[0]).to_integer_32 /= a_accept2 then
									if (l_s[0]).to_integer_32 = a_accept3 then
										l_pos := -1 + 4 -- break
									end
								else
									l_pos := -1 + 4 -- break
								end
							else
								l_pos := -1 + 4 -- break
							end
						else
							l_pos := -1 + 4 -- break
						end
				when 3 then
						l_s := l_s + 1
						l_pos := -1 + 1 -- back to loop condition
				when 4 then -- loop done
					if (l_s[0]).to_integer_32 = 0 then
						l_tmp := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					else
						l_tmp := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer + ((l_s.c_pointer.to_integer_32).to_natural_32).to_integer_32)
					end
					Result := l_tmp
					l_pos := -1 + -1 -- return
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	strtok_r_1c (a_s: CE_POINTER [INTEGER_8]; a_sep: INTEGER_8; a_nextp: CE_POINTER [CE_POINTER [INTEGER_8]]): CE_POINTER [INTEGER_8]
		local
			l_s: CE_POINTER [INTEGER_8]
			l_result: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_tmp_0: CE_POINTER [INTEGER_8]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_s := a_s
					if l_s.is_void then
						l_s := a_nextp.item
					end
					from
					until
						(l_s[0]).to_integer_32 /= a_sep.to_integer_32
					loop
						l_s := l_s + 1
					end
					l_result := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
					if (l_s[0]).to_integer_32 = 0 then
						l_pos := -1 + 5 -- skip if block
					end
				when 1 then -- if:
						l_tmp := l_s
						l_s := l_s + 1
						l_result := l_tmp
				when 2 then -- loop condition:
						if (l_s[0]).to_integer_32 = 0 then
							l_pos := -1 + 5 -- skip loop
						end
				when 3 then -- loop body:
						l_tmp_0 := l_s
						l_s := l_s + 1
						if (l_tmp_0[0]).to_integer_32 = a_sep.to_integer_32 then
							l_s[-1] := (('%/0/').code).to_integer_8
							l_pos := -1 + 5 -- break
						end
				when 4 then
						l_pos := -1 + 2 -- back to loop condition
				when 5 then -- loop done | if done
					a_nextp.item := l_s
					Result := l_result
					l_pos := -1 + -1 -- return
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	strsep_2c (a_s: CE_POINTER [CE_POINTER [INTEGER_8]]; a_reject1, a_reject2: INTEGER_8): CE_POINTER [INTEGER_8]
		local
			l_retval: CE_POINTER [INTEGER_8]
			l_cp: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_retval := a_s.item
					if l_retval.is_void then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						l_cp := l_retval
				when 2 then -- loop condition:
						if False then
							l_pos := -1 + 6 -- skip loop
						end
				when 3 then -- loop body:
						if (l_cp[0]).to_integer_32 = 0 then
							l_cp := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							l_pos := -1 + 6 -- break
						end
				when 4 then
						if (l_cp[0]).to_integer_32 = a_reject1.to_integer_32 then
							l_tmp := l_cp
							l_cp := l_cp + 1
							l_tmp[0] := (('%/0/').code).to_integer_8
							l_pos := -1 + 6 -- break
						elseif (l_cp[0]).to_integer_32 = a_reject2.to_integer_32 then
							l_tmp := l_cp
							l_cp := l_cp + 1
							l_tmp[0] := (('%/0/').code).to_integer_8
							l_pos := -1 + 6 -- break
						end
				when 5 then
						l_cp := l_cp + 1
						l_pos := -1 + 2 -- back to loop condition
				when 6 then -- loop done
						a_s.item := l_cp
				when 7 then -- if done
					Result := l_retval
					l_pos := -1 + -1 -- return
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	strsep_3c (a_s: CE_POINTER [CE_POINTER [INTEGER_8]]; a_reject1, a_reject2, a_reject3: INTEGER_8): CE_POINTER [INTEGER_8]
		local
			l_retval: CE_POINTER [INTEGER_8]
			l_cp: CE_POINTER [INTEGER_8]
			l_tmp: CE_POINTER [INTEGER_8]
			l_pos: INTEGER_32
		do
			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_retval := a_s.item
					if l_retval.is_void then
						l_pos := -1 + 7 -- skip if block
					end
				when 1 then -- if:
						l_cp := l_retval
				when 2 then -- loop condition:
						if False then
							l_pos := -1 + 6 -- skip loop
						end
				when 3 then -- loop body:
						if (l_cp[0]).to_integer_32 = 0 then
							l_cp := create {CE_INTEGER_8_POINTER}.make_shared (default_pointer)
							l_pos := -1 + 6 -- break
						end
				when 4 then
						if (l_cp[0]).to_integer_32 = a_reject1.to_integer_32 then
							l_tmp := l_cp
							l_cp := l_cp + 1
							l_tmp[0] := (('%/0/').code).to_integer_8
							l_pos := -1 + 6 -- break
						elseif (l_cp[0]).to_integer_32 = a_reject2.to_integer_32 then
							l_tmp := l_cp
							l_cp := l_cp + 1
							l_tmp[0] := (('%/0/').code).to_integer_8
							l_pos := -1 + 6 -- break
						elseif (l_cp[0]).to_integer_32 = a_reject3.to_integer_32 then
							l_tmp := l_cp
							l_cp := l_cp + 1
							l_tmp[0] := (('%/0/').code).to_integer_8
							l_pos := -1 + 6 -- break
						end
				when 5 then
						l_cp := l_cp + 1
						l_pos := -1 + 2 -- back to loop condition
				when 6 then -- loop done
						a_s.item := l_cp
				when 7 then -- if done
					Result := l_retval
					l_pos := -1 + -1 -- return
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

	memcmp (a_s1, a_s2: CE_POINTER [ANY]; a_n: NATURAL_32): INTEGER_32
		do
			Result := c_memcmp (a_s1.c_pointer, a_s2.c_pointer, a_n)
		end

	c_memcmp (a_s1: POINTER; a_s2: POINTER; a_n: NATURAL_32): INTEGER_32
		external
			"C inline use <sdl_mixer.h>"
		alias
			"return memcmp($a_s1, $a_s2, $a_n);"
		end

	memcpy (a_dest, a_src: CE_POINTER [ANY]; a_n: NATURAL_32): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared (c_memcpy (a_dest.c_pointer, a_src.c_pointer, a_n))
		end

	c_memcpy (a_dest: POINTER; a_src: POINTER; a_n: NATURAL_32): POINTER
		external
			"C inline use <sdl_mixer.h>"
		alias
			"return (EIF_POINTER)memcpy($a_dest, $a_src, $a_n);"
		end

	strcpy (a_dest, a_src: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c_strcpy (a_dest.c_pointer, a_src.c_pointer))
		end

	c_strcpy (a_dest: POINTER; a_src: POINTER): POINTER
		external
			"C inline use <sdl_mixer.h>"
		alias
			"return (EIF_POINTER)strcpy($a_dest, $a_src);"
		end

	strcmp (a_str1, a_str2: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_strcmp (a_str1.c_pointer, a_str2.c_pointer)
		end

	c_strcmp (a_str1: POINTER; a_str2: POINTER): INTEGER_32
		external
			"C inline use <sdl_mixer.h>"
		alias
			"return strcmp($a_str1, $a_str2);"
		end

	strncmp (a_s1, a_s2: CE_POINTER [INTEGER_8]; a_n: NATURAL_32): INTEGER_32
		do
			Result := c_strncmp (a_s1.c_pointer, a_s2.c_pointer, a_n)
		end

	c_strncmp (a_s1: POINTER; a_s2: POINTER; a_n: NATURAL_32): INTEGER_32
		external
			"C inline use <sdl_mixer.h>"
		alias
			"return strncmp($a_s1, $a_s2, $a_n);"
		end

	strrchr (a_s: CE_POINTER [INTEGER_8]; a_c: INTEGER_32): CE_POINTER [INTEGER_8]
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c_strrchr (a_s.c_pointer, a_c))
		end

	c_strrchr (a_s: POINTER; a_c: INTEGER_32): POINTER
		external
			"C inline use <sdl_mixer.h>"
		alias
			"return (EIF_POINTER)strrchr($a_s, $a_c);"
		end

	strlen (a_s: CE_POINTER [INTEGER_8]): NATURAL_32
		do
			Result := c_strlen (a_s.c_pointer)
		end

	c_strlen (a_s: POINTER): NATURAL_32
		external
			"C inline use <sdl_mixer.h>"
		alias
			"return strlen($a_s);"
		end

end
