class
	SD_STDIO

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			make_initialized,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_autoclose: INTEGER_32
				a_fp: CE_POINTER [SD_IO_FILE]
			])
		require else
			a_data /= Void
		do
			make
			Current.autoclose := a_data.a_autoclose
			Current.fp := a_data.a_fp
		end

feature {ANY} -- fields

	autoclose: INTEGER_32 assign set_autoclose
		do
			Result := c__autoclose (internal_c_pointer)
		end

	fp: CE_POINTER [SD_IO_FILE] assign set_fp
		do
			create {CE_CLASS_POINTER [SD_IO_FILE]} Result.make_shared (c__fp (internal_c_pointer))
		end

feature {ANY} -- field setters

	set_autoclose (a_autoclose: INTEGER_32)
		do
			c__set_autoclose (internal_c_pointer, a_autoclose)
		end

	set_fp (a_fp: CE_POINTER [SD_IO_FILE])
		do
			c__set_fp (internal_c_pointer, a_fp.c_pointer)
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return sizeof(struct __anonstruct_stdio_35);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return __alignof__(struct __anonstruct_stdio_35);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__autoclose (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct __anonstruct_stdio_35 *)$a_c_pointer)->autoclose;"
		end

	c__fp (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct __anonstruct_stdio_35 *)$a_c_pointer)->fp;"
		end

	c__set_autoclose (a_c_pointer: POINTER; a_autoclose: INTEGER_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct __anonstruct_stdio_35 *)$a_c_pointer)->autoclose = $a_autoclose;"
		end

	c__set_fp (a_c_pointer: POINTER; a_fp: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct __anonstruct_stdio_35 *)$a_c_pointer)->fp = $a_fp;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "autoclose") == 0) return offsetof(struct __anonstruct_stdio_35, autoclose);
				if(strcmp($a_field_name, "fp") == 0) return offsetof(struct __anonstruct_stdio_35, fp);
				fprintf(stderr, "struct __anonstruct_stdio_35.%s not found\n", $a_field_name);
				return -1;
			]"
		end

end
