class
	P_LOAD_AIFF_STATIC

inherit
	CE_UTILITIES
	S_SDL_SDL_RWOPS_STATIC
	S_SDL_SDL_ERROR_STATIC
	S_STRING_STATIC
	S_STDLIB_STATIC

feature {ANY} -- public routines

	sane_to_uint32 (a_sanebuf: CE_POINTER [NATURAL_8]): NATURAL_32
		local
			l_return: BOOLEAN
		do
			if (((a_sanebuf[0]).to_integer_32).bit_and (128)).to_boolean then
				Result := (0).to_natural_32
				l_return := True
			elseif (a_sanebuf[0]).to_integer_32 <= 63 then
				Result := (0).to_natural_32
				l_return := True
			elseif (a_sanebuf[0]).to_integer_32 > 64 then
				Result := (0).to_natural_32
				l_return := True
			elseif (a_sanebuf[0]).to_integer_32 = 64 then
				if (a_sanebuf[1]).to_integer_32 > 28 then
					Result := (0).to_natural_32
					l_return := True
				end
			end
			if not l_return then
				Result := (((((((((((a_sanebuf[2]).to_integer_32).bit_shift_left (23))).bit_or ((((a_sanebuf[3]).to_integer_32).bit_shift_left (15))))).bit_or ((((a_sanebuf[4]).to_integer_32).bit_shift_left (7))))).bit_or ((((a_sanebuf[5]).to_integer_32).bit_shift_right (1))))).bit_shift_right ((29 - (a_sanebuf[1]).to_integer_32))).to_natural_32
			end
		end

	mix_load_aiff_rw (a_src: CE_POINTER [SD_SDL_RWOPS]; a_freesrc: INTEGER_32; a_spec: CE_POINTER [SD_SDL_AUDIOSPEC]; a_audio_buf: CE_POINTER [CE_POINTER [NATURAL_8]]; a_audio_len: CE_POINTER [NATURAL_32]): CE_POINTER [SD_SDL_AUDIOSPEC]
		local
			l_spec: CE_POINTER [SD_SDL_AUDIOSPEC]
			l_was_error: INTEGER_32
			l_found_ssnd: INTEGER_32
			l_found_comm: INTEGER_32
			l_found_vhdr: INTEGER_32
			l_found_body: INTEGER_32
			l_start: INTEGER_32
			l_chunk_type: NATURAL_32
			l_chunk_length: NATURAL_32
			l_next_chunk: INTEGER_32
			l_formchunk: NATURAL_32
			l_aiffmagic: NATURAL_32
			l_offset: NATURAL_32
			l_blocksize: NATURAL_32
			l_channels: NATURAL_16
			l_numsamples: NATURAL_32
			l_samplesize: NATURAL_16
			l_sane_freq: CE_ARRAY [NATURAL_8]
			l_frequency: NATURAL_32
			l_return, l_break: BOOLEAN
			l_pos: INTEGER_32
		do
			create {CE_NATURAL_8_ARRAY} l_sane_freq.make (<<10>>)

			from until l_pos = -1 loop -- -1: return
				inspect l_pos

				-- <function body>
				when 0 then -- execution start:
					l_spec := a_spec
					l_start := 0
					l_channels := (0).to_natural_16
					l_numsamples := (0).to_natural_32
					l_samplesize := (0).to_natural_16
					l_frequency := (0).to_natural_32
					l_was_error := 0
					if a_src.is_void then
						l_was_error := 1
						l_pos := -1 + 36 -- goto done
					end
				when 1 then
					l_formchunk := sdl_read_le32 (a_src)
					l_chunk_length := sdl_read_be32 (a_src)
					if l_chunk_length = {NATURAL_32} 1_179_011_393 then
						l_aiffmagic := l_chunk_length
						l_chunk_length := l_formchunk
						l_formchunk := (1_297_239_878).to_natural_32
					else
						l_aiffmagic := sdl_read_le32 (a_src)
					end
					if l_formchunk /= {NATURAL_32} 1_297_239_878 then
						sdl_set_error ([ce_string ("Unrecognized file type (not AIFF nor 8SVX)")])
						l_was_error := 1
						l_pos := -1 + 36 -- goto done
					elseif l_aiffmagic /= {NATURAL_32} 1_179_011_393 then
						if l_aiffmagic /= {NATURAL_32} 1_482_052_408 then
							sdl_set_error ([ce_string ("Unrecognized file type (not AIFF nor 8SVX)")])
							l_was_error := 1
							l_pos := -1 + 36 -- goto done
						end
					end
				when 2 then
					l_found_ssnd := 0
					l_found_comm := 0
					l_found_vhdr := 0
					l_found_body := 0
				when 3 then -- loop condition:
					if (l_break) then
						l_pos := -1 + 26 -- skip loop
					end
				when 4 then -- loop body:
						l_break := False
						l_chunk_type := sdl_read_le32 (a_src)
						l_chunk_length := sdl_read_be32 (a_src)
						l_next_chunk := (((a_src.item.seek).integer_32_item ([a_src, 0, 1])).to_natural_32 + l_chunk_length).to_integer_32
						if l_chunk_length = {NATURAL_32} 0 then
							l_break := True
						end
						if (l_break) then
							l_pos := -1 + 25 -- skip if block
						end
				when 5 then -- if:
						inspect l_chunk_type -- switch 1 head
						when 1145983827 then l_pos := -1 + 6
						when 1296912195 then l_pos := -1 + 7
						when 1380206678 then l_pos := -1 + 9
						when 1497648962 then l_pos := -1 + 10
						else l_pos := -1 + 11
						end
				when 6 then -- switch 1, case 1145983827u
						l_found_ssnd := 1
						l_offset := sdl_read_be32 (a_src)
						l_blocksize := sdl_read_be32 (a_src)
						l_start := (((a_src.item.seek).integer_32_item ([a_src, 0, 1])).to_natural_32 + l_offset).to_integer_32
						l_pos := -1 + 12 -- switch 1; break
				when 7 then -- switch 1, case 1296912195u
						l_found_comm := 1
						l_channels := sdl_read_be16 (a_src)
						l_numsamples := sdl_read_be32 (a_src)
						l_samplesize := sdl_read_be16 (a_src)
						(a_src.item.read).call ([a_src, create {CE_VOID_POINTER}.make_cast (l_sane_freq), ({PLATFORM}.Natural_8_bytes.to_natural_32 * (10).to_natural_32).to_integer_32, 1])
						l_frequency := sane_to_uint32 (l_sane_freq)
						if l_frequency = {NATURAL_32} 0 then
							sdl_set_error ([ce_string ("Bad AIFF sample frequency")])
							l_was_error := 1
							l_pos := -1 + 36 -- goto done
						end
				when 8 then
						l_pos := -1 + 12 -- switch 1; break
				when 9 then -- switch 1, case 1380206678u
						l_found_vhdr := 1
						sdl_read_be32 (a_src).do_nothing
						sdl_read_be32 (a_src).do_nothing
						sdl_read_be32 (a_src).do_nothing
						l_frequency := (sdl_read_be16 (a_src)).to_natural_32
						l_channels := (1).to_natural_16
						l_samplesize := (8).to_natural_16
						l_pos := -1 + 12 -- switch 1; break
				when 10 then -- switch 1, case 1497648962u
						l_found_body := 1
						l_numsamples := l_chunk_length
						l_start := ((a_src.item.seek).integer_32_item ([a_src, 0, 1])).to_integer_32
						l_pos := -1 + 12 -- switch 1; break
				when 11 then -- switch 1, default:
						l_pos := -1 + 12 -- switch 1; break
				when 12 then -- switch 1, done:
						if ((l_chunk_length).bit_and ({NATURAL_32} 1)).to_boolean then
							l_next_chunk := l_next_chunk + 1
						end
						if l_aiffmagic /= {NATURAL_32} 1_179_011_393 then
							l_pos := -1 + 15 -- skip if block
						end
				when 13 then -- if:
						if not l_found_ssnd.to_boolean then
							l_pos := -1 + 20 -- goto _L___0
						elseif not l_found_comm.to_boolean then
							l_pos := -1 + 20 -- goto _L___0
						else
							l_pos := -1 + 15 -- goto _L___1
						end
				when 14 then -- if block done, skip else block:
						l_pos := -1 + 25
				when 15 then -- else: | _L___1:
						if l_aiffmagic /= {NATURAL_32} 1_482_052_408 then
							l_pos := -1 + 24 -- skip if block
						end
				when 16 then -- if:
						if l_found_vhdr.to_boolean then
							l_pos := -1 + 19 -- skip if block
						end
				when 17 then -- if:
						l_pos := -1 + 20 -- goto _L___0
				when 18 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 19 then -- else:
						if l_found_body.to_boolean then
							l_pos := -1 + 22 -- skip if block
						end
				when 20 then -- if: | _L___0:
						if ((a_src.item.seek).integer_32_item ([a_src, l_next_chunk.to_integer_32, 0])) = 1 then
							l_break := True
						end
				when 21 then -- if block done, skip else block:
						l_pos := -1 + 23
				when 22 then -- else:
						l_break := True
				when 23 then -- if done | if done | if block done, skip else block:
						l_pos := -1 + 25
				when 24 then -- else:
						l_break := True
				when 25 then -- if done | if done
						l_pos := -1 + 3 -- back to loop condition
				when 26 then -- loop done
					l_break := False
					if l_aiffmagic = {NATURAL_32} 1_179_011_393 then
						if not l_found_ssnd.to_boolean then
							sdl_set_error ([ce_string ("Bad AIFF (no SSND chunk)")])
							l_was_error := 1
							l_pos := -1 + 36 -- goto done
						end
					end
				when 27 then
					if l_aiffmagic = {NATURAL_32} 1_179_011_393 then
						if not l_found_comm.to_boolean then
							sdl_set_error ([ce_string ("Bad AIFF (no COMM chunk)")])
							l_was_error := 1
							l_pos := -1 + 36 -- goto done
						end
					end
				when 28 then
					if l_aiffmagic = {NATURAL_32} 1_482_052_408 then
						if not l_found_vhdr.to_boolean then
							sdl_set_error ([ce_string ("Bad 8SVX (no VHDR chunk)")])
							l_was_error := 1
							l_pos := -1 + 36 -- goto done
						end
					end
				when 29 then
					if l_aiffmagic = {NATURAL_32} 1_482_052_408 then
						if not l_found_body.to_boolean then
							sdl_set_error ([ce_string ("Bad 8SVX (no BODY chunk)")])
							l_was_error := 1
							l_pos := -1 + 36 -- goto done
						end
					end
				when 30 then
					memset (create {CE_VOID_POINTER}.make_cast (l_spec), 0, (create {SD_SDL_AUDIOSPEC}.make).structure_size.to_natural_32).do_nothing
					l_spec.item.freq := l_frequency.to_integer_32
					inspect l_samplesize.to_integer_32 -- switch 2 head
					when 8 then l_pos := -1 + 31
					when 16 then l_pos := -1 + 32
					else l_pos := -1 + 33
					end
				when 31 then -- switch 2, case 8
					l_spec.item.format := (32_776).to_natural_16
					l_pos := -1 + 34 -- switch 2; break
				when 32 then -- switch 2, case 16
					l_spec.item.format := (36_880).to_natural_16
					l_pos := -1 + 34 -- switch 2; break
				when 33 then -- switch 2, default:
					sdl_set_error ([ce_string ("Unsupported AIFF samplesize")])
					l_was_error := 1
					l_pos := -1 + 36 -- goto done
				when 34 then -- switch 2, done:
					l_spec.item.channels := l_channels.to_natural_8
					l_spec.item.samples := (4_096).to_natural_16
					a_audio_len.item := (l_channels.to_natural_32 * l_numsamples) * (l_samplesize.to_integer_32 // 8).to_natural_32
					a_audio_buf.item := create {CE_NATURAL_8_POINTER}.make_cast ((malloc (a_audio_len.item)))
					if (a_audio_buf.item).is_void then
						sdl_set_error ([ce_string ("Out of memory")])
						Result := (create {CE_CLASS_POINTER [SD_SDL_AUDIOSPEC]}.make_shared (default_pointer))
						l_return := True
					end
					if not l_return then
						(a_src.item.seek).call ([a_src, l_start.to_integer_32, 0])
						if ((a_src.item.read).integer_32_item ([a_src, create {CE_VOID_POINTER}.make_cast (a_audio_buf.item), (a_audio_len.item).to_integer_32, 1])) /= 1 then
							sdl_set_error ([ce_string ("Unable to read audio data")])
							Result := (create {CE_CLASS_POINTER [SD_SDL_AUDIOSPEC]}.make_shared (default_pointer))
							l_return := True
						end
					end
					if l_return then
						l_pos := -1 + 37 -- skip if block
					end
				when 35 then -- if:
						a_audio_len.item := (a_audio_len.item).bit_and ((((l_samplesize.to_integer_32 // 8 - 1)).bit_not).to_natural_32)
				when 36 then -- done:
						if a_freesrc.to_boolean then
							if (not a_src.is_void) then
								(a_src.item.close).call ([a_src])
							end
						end
						if l_was_error.to_boolean then
							l_spec := create {CE_CLASS_POINTER [SD_SDL_AUDIOSPEC]}.make_shared (default_pointer)
						end
						Result := l_spec
				when 37 then
					l_pos := -1 + -1 -- end of function
				end
				-- </function body>

				l_pos := l_pos + 1
			end
		end

end
