class
	PD_DATA

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			make_initialized,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_wave: CE_POINTER [PD_WAVSTREAM]
				a_mp3: CE_POINTER [ANY]
			])
		require else
			a_data /= Void
		do
			make
			Current.wave := a_data.a_wave
			Current.mp3 := a_data.a_mp3
		end

feature {ANY} -- fields

	wave: CE_POINTER [PD_WAVSTREAM] assign set_wave
		do
			create {CE_CLASS_POINTER [PD_WAVSTREAM]} Result.make_shared (c__wave (internal_c_pointer))
		end

	mp3: CE_POINTER [ANY] assign set_mp3
		do
			create {CE_VOID_POINTER} Result.make_shared (c__mp3 (internal_c_pointer))
		end

feature {ANY} -- field setters

	set_wave (a_wave: CE_POINTER [PD_WAVSTREAM])
		do
			c__set_wave (internal_c_pointer, a_wave.c_pointer)
		end

	set_mp3 (a_mp3: CE_POINTER [ANY])
		do
			c__set_mp3 (internal_c_pointer, a_mp3.c_pointer)
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return sizeof(union __anonunion_data_54);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return __alignof__(union __anonunion_data_54);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_union (<<>>)
			Result.alignment := structure_alignment
		end

	c__wave (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((union __anonunion_data_54 *)$a_c_pointer)->wave;"
		end

	c__mp3 (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((union __anonunion_data_54 *)$a_c_pointer)->mp3;"
		end

	c__set_wave (a_c_pointer: POINTER; a_wave: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((union __anonunion_data_54 *)$a_c_pointer)->wave = $a_wave;"
		end

	c__set_mp3 (a_c_pointer: POINTER; a_mp3: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((union __anonunion_data_54 *)$a_c_pointer)->mp3 = $a_mp3;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "wave") == 0) return offsetof(union __anonunion_data_54, wave);
				if(strcmp($a_field_name, "mp3") == 0) return offsetof(union __anonunion_data_54, mp3);
				fprintf(stderr, "union __anonunion_data_54.%s not found\n", $a_field_name);
				return -1;
			]"
		end

end
