class
	PD_EFF_POSITIONARGS

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			make_initialized,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_left_f: REAL_32
				a_right_f: REAL_32
				a_left_u8: NATURAL_8
				a_right_u8: NATURAL_8
				a_left_rear_f: REAL_32
				a_right_rear_f: REAL_32
				a_center_f: REAL_32
				a_lfe_f: REAL_32
				a_left_rear_u8: NATURAL_8
				a_right_rear_u8: NATURAL_8
				a_center_u8: NATURAL_8
				a_lfe_u8: NATURAL_8
				a_distance_f: REAL_32
				a_distance_u8: NATURAL_8
				a_room_angle: INTEGER_16
				a_in_use: INTEGER_32
				a_channels: INTEGER_32
			])
		require else
			a_data /= Void
		do
			make
			Current.left_f := a_data.a_left_f
			Current.right_f := a_data.a_right_f
			Current.left_u8 := a_data.a_left_u8
			Current.right_u8 := a_data.a_right_u8
			Current.left_rear_f := a_data.a_left_rear_f
			Current.right_rear_f := a_data.a_right_rear_f
			Current.center_f := a_data.a_center_f
			Current.lfe_f := a_data.a_lfe_f
			Current.left_rear_u8 := a_data.a_left_rear_u8
			Current.right_rear_u8 := a_data.a_right_rear_u8
			Current.center_u8 := a_data.a_center_u8
			Current.lfe_u8 := a_data.a_lfe_u8
			Current.distance_f := a_data.a_distance_f
			Current.distance_u8 := a_data.a_distance_u8
			Current.room_angle := a_data.a_room_angle
			Current.in_use := a_data.a_in_use
			Current.channels := a_data.a_channels
		end

feature {ANY} -- fields

	left_f: REAL_32 assign set_left_f
		do
			Result := c__left_f (internal_c_pointer)
		end

	right_f: REAL_32 assign set_right_f
		do
			Result := c__right_f (internal_c_pointer)
		end

	left_u8: NATURAL_8 assign set_left_u8
		do
			Result := c__left_u8 (internal_c_pointer)
		end

	right_u8: NATURAL_8 assign set_right_u8
		do
			Result := c__right_u8 (internal_c_pointer)
		end

	left_rear_f: REAL_32 assign set_left_rear_f
		do
			Result := c__left_rear_f (internal_c_pointer)
		end

	right_rear_f: REAL_32 assign set_right_rear_f
		do
			Result := c__right_rear_f (internal_c_pointer)
		end

	center_f: REAL_32 assign set_center_f
		do
			Result := c__center_f (internal_c_pointer)
		end

	lfe_f: REAL_32 assign set_lfe_f
		do
			Result := c__lfe_f (internal_c_pointer)
		end

	left_rear_u8: NATURAL_8 assign set_left_rear_u8
		do
			Result := c__left_rear_u8 (internal_c_pointer)
		end

	right_rear_u8: NATURAL_8 assign set_right_rear_u8
		do
			Result := c__right_rear_u8 (internal_c_pointer)
		end

	center_u8: NATURAL_8 assign set_center_u8
		do
			Result := c__center_u8 (internal_c_pointer)
		end

	lfe_u8: NATURAL_8 assign set_lfe_u8
		do
			Result := c__lfe_u8 (internal_c_pointer)
		end

	distance_f: REAL_32 assign set_distance_f
		do
			Result := c__distance_f (internal_c_pointer)
		end

	distance_u8: NATURAL_8 assign set_distance_u8
		do
			Result := c__distance_u8 (internal_c_pointer)
		end

	room_angle: INTEGER_16 assign set_room_angle
		do
			Result := c__room_angle (internal_c_pointer)
		end

	in_use: INTEGER_32 assign set_in_use
		do
			Result := c__in_use (internal_c_pointer)
		end

	channels: INTEGER_32 assign set_channels
		do
			Result := c__channels (internal_c_pointer)
		end

feature {ANY} -- field setters

	set_left_f (a_left_f: REAL_32)
		do
			c__set_left_f (internal_c_pointer, a_left_f)
		end

	set_right_f (a_right_f: REAL_32)
		do
			c__set_right_f (internal_c_pointer, a_right_f)
		end

	set_left_u8 (a_left_u8: NATURAL_8)
		do
			c__set_left_u8 (internal_c_pointer, a_left_u8)
		end

	set_right_u8 (a_right_u8: NATURAL_8)
		do
			c__set_right_u8 (internal_c_pointer, a_right_u8)
		end

	set_left_rear_f (a_left_rear_f: REAL_32)
		do
			c__set_left_rear_f (internal_c_pointer, a_left_rear_f)
		end

	set_right_rear_f (a_right_rear_f: REAL_32)
		do
			c__set_right_rear_f (internal_c_pointer, a_right_rear_f)
		end

	set_center_f (a_center_f: REAL_32)
		do
			c__set_center_f (internal_c_pointer, a_center_f)
		end

	set_lfe_f (a_lfe_f: REAL_32)
		do
			c__set_lfe_f (internal_c_pointer, a_lfe_f)
		end

	set_left_rear_u8 (a_left_rear_u8: NATURAL_8)
		do
			c__set_left_rear_u8 (internal_c_pointer, a_left_rear_u8)
		end

	set_right_rear_u8 (a_right_rear_u8: NATURAL_8)
		do
			c__set_right_rear_u8 (internal_c_pointer, a_right_rear_u8)
		end

	set_center_u8 (a_center_u8: NATURAL_8)
		do
			c__set_center_u8 (internal_c_pointer, a_center_u8)
		end

	set_lfe_u8 (a_lfe_u8: NATURAL_8)
		do
			c__set_lfe_u8 (internal_c_pointer, a_lfe_u8)
		end

	set_distance_f (a_distance_f: REAL_32)
		do
			c__set_distance_f (internal_c_pointer, a_distance_f)
		end

	set_distance_u8 (a_distance_u8: NATURAL_8)
		do
			c__set_distance_u8 (internal_c_pointer, a_distance_u8)
		end

	set_room_angle (a_room_angle: INTEGER_16)
		do
			c__set_room_angle (internal_c_pointer, a_room_angle)
		end

	set_in_use (a_in_use: INTEGER_32)
		do
			c__set_in_use (internal_c_pointer, a_in_use)
		end

	set_channels (a_channels: INTEGER_32)
		do
			c__set_channels (internal_c_pointer, a_channels)
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return sizeof(struct _Eff_positionargs);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return __alignof__(struct _Eff_positionargs);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__left_f (a_c_pointer: POINTER): REAL_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _Eff_positionargs *)$a_c_pointer)->left_f;"
		end

	c__right_f (a_c_pointer: POINTER): REAL_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _Eff_positionargs *)$a_c_pointer)->right_f;"
		end

	c__left_u8 (a_c_pointer: POINTER): NATURAL_8
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _Eff_positionargs *)$a_c_pointer)->left_u8;"
		end

	c__right_u8 (a_c_pointer: POINTER): NATURAL_8
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _Eff_positionargs *)$a_c_pointer)->right_u8;"
		end

	c__left_rear_f (a_c_pointer: POINTER): REAL_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _Eff_positionargs *)$a_c_pointer)->left_rear_f;"
		end

	c__right_rear_f (a_c_pointer: POINTER): REAL_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _Eff_positionargs *)$a_c_pointer)->right_rear_f;"
		end

	c__center_f (a_c_pointer: POINTER): REAL_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _Eff_positionargs *)$a_c_pointer)->center_f;"
		end

	c__lfe_f (a_c_pointer: POINTER): REAL_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _Eff_positionargs *)$a_c_pointer)->lfe_f;"
		end

	c__left_rear_u8 (a_c_pointer: POINTER): NATURAL_8
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _Eff_positionargs *)$a_c_pointer)->left_rear_u8;"
		end

	c__right_rear_u8 (a_c_pointer: POINTER): NATURAL_8
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _Eff_positionargs *)$a_c_pointer)->right_rear_u8;"
		end

	c__center_u8 (a_c_pointer: POINTER): NATURAL_8
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _Eff_positionargs *)$a_c_pointer)->center_u8;"
		end

	c__lfe_u8 (a_c_pointer: POINTER): NATURAL_8
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _Eff_positionargs *)$a_c_pointer)->lfe_u8;"
		end

	c__distance_f (a_c_pointer: POINTER): REAL_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _Eff_positionargs *)$a_c_pointer)->distance_f;"
		end

	c__distance_u8 (a_c_pointer: POINTER): NATURAL_8
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _Eff_positionargs *)$a_c_pointer)->distance_u8;"
		end

	c__room_angle (a_c_pointer: POINTER): INTEGER_16
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _Eff_positionargs *)$a_c_pointer)->room_angle;"
		end

	c__in_use (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _Eff_positionargs *)$a_c_pointer)->in_use;"
		end

	c__channels (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _Eff_positionargs *)$a_c_pointer)->channels;"
		end

	c__set_left_f (a_c_pointer: POINTER; a_left_f: REAL_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Eff_positionargs *)$a_c_pointer)->left_f = $a_left_f;"
		end

	c__set_right_f (a_c_pointer: POINTER; a_right_f: REAL_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Eff_positionargs *)$a_c_pointer)->right_f = $a_right_f;"
		end

	c__set_left_u8 (a_c_pointer: POINTER; a_left_u8: NATURAL_8)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Eff_positionargs *)$a_c_pointer)->left_u8 = $a_left_u8;"
		end

	c__set_right_u8 (a_c_pointer: POINTER; a_right_u8: NATURAL_8)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Eff_positionargs *)$a_c_pointer)->right_u8 = $a_right_u8;"
		end

	c__set_left_rear_f (a_c_pointer: POINTER; a_left_rear_f: REAL_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Eff_positionargs *)$a_c_pointer)->left_rear_f = $a_left_rear_f;"
		end

	c__set_right_rear_f (a_c_pointer: POINTER; a_right_rear_f: REAL_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Eff_positionargs *)$a_c_pointer)->right_rear_f = $a_right_rear_f;"
		end

	c__set_center_f (a_c_pointer: POINTER; a_center_f: REAL_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Eff_positionargs *)$a_c_pointer)->center_f = $a_center_f;"
		end

	c__set_lfe_f (a_c_pointer: POINTER; a_lfe_f: REAL_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Eff_positionargs *)$a_c_pointer)->lfe_f = $a_lfe_f;"
		end

	c__set_left_rear_u8 (a_c_pointer: POINTER; a_left_rear_u8: NATURAL_8)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Eff_positionargs *)$a_c_pointer)->left_rear_u8 = $a_left_rear_u8;"
		end

	c__set_right_rear_u8 (a_c_pointer: POINTER; a_right_rear_u8: NATURAL_8)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Eff_positionargs *)$a_c_pointer)->right_rear_u8 = $a_right_rear_u8;"
		end

	c__set_center_u8 (a_c_pointer: POINTER; a_center_u8: NATURAL_8)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Eff_positionargs *)$a_c_pointer)->center_u8 = $a_center_u8;"
		end

	c__set_lfe_u8 (a_c_pointer: POINTER; a_lfe_u8: NATURAL_8)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Eff_positionargs *)$a_c_pointer)->lfe_u8 = $a_lfe_u8;"
		end

	c__set_distance_f (a_c_pointer: POINTER; a_distance_f: REAL_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Eff_positionargs *)$a_c_pointer)->distance_f = $a_distance_f;"
		end

	c__set_distance_u8 (a_c_pointer: POINTER; a_distance_u8: NATURAL_8)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Eff_positionargs *)$a_c_pointer)->distance_u8 = $a_distance_u8;"
		end

	c__set_room_angle (a_c_pointer: POINTER; a_room_angle: INTEGER_16)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Eff_positionargs *)$a_c_pointer)->room_angle = $a_room_angle;"
		end

	c__set_in_use (a_c_pointer: POINTER; a_in_use: INTEGER_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Eff_positionargs *)$a_c_pointer)->in_use = $a_in_use;"
		end

	c__set_channels (a_c_pointer: POINTER; a_channels: INTEGER_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Eff_positionargs *)$a_c_pointer)->channels = $a_channels;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "left_f") == 0) return offsetof(struct _Eff_positionargs, left_f);
				if(strcmp($a_field_name, "right_f") == 0) return offsetof(struct _Eff_positionargs, right_f);
				if(strcmp($a_field_name, "left_u8") == 0) return offsetof(struct _Eff_positionargs, left_u8);
				if(strcmp($a_field_name, "right_u8") == 0) return offsetof(struct _Eff_positionargs, right_u8);
				if(strcmp($a_field_name, "left_rear_f") == 0) return offsetof(struct _Eff_positionargs, left_rear_f);
				if(strcmp($a_field_name, "right_rear_f") == 0) return offsetof(struct _Eff_positionargs, right_rear_f);
				if(strcmp($a_field_name, "center_f") == 0) return offsetof(struct _Eff_positionargs, center_f);
				if(strcmp($a_field_name, "lfe_f") == 0) return offsetof(struct _Eff_positionargs, lfe_f);
				if(strcmp($a_field_name, "left_rear_u8") == 0) return offsetof(struct _Eff_positionargs, left_rear_u8);
				if(strcmp($a_field_name, "right_rear_u8") == 0) return offsetof(struct _Eff_positionargs, right_rear_u8);
				if(strcmp($a_field_name, "center_u8") == 0) return offsetof(struct _Eff_positionargs, center_u8);
				if(strcmp($a_field_name, "lfe_u8") == 0) return offsetof(struct _Eff_positionargs, lfe_u8);
				if(strcmp($a_field_name, "distance_f") == 0) return offsetof(struct _Eff_positionargs, distance_f);
				if(strcmp($a_field_name, "distance_u8") == 0) return offsetof(struct _Eff_positionargs, distance_u8);
				if(strcmp($a_field_name, "room_angle") == 0) return offsetof(struct _Eff_positionargs, room_angle);
				if(strcmp($a_field_name, "in_use") == 0) return offsetof(struct _Eff_positionargs, in_use);
				if(strcmp($a_field_name, "channels") == 0) return offsetof(struct _Eff_positionargs, channels);
				fprintf(stderr, "struct _Eff_positionargs.%s not found\n", $a_field_name);
				return -1;
			]"
		end

end
