class
	PD_MIX_CHANNEL

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			make_initialized,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_chunk: CE_POINTER [PD_MIX_CHUNK]
				a_playing: INTEGER_32
				a_paused: INTEGER_32
				a_samples: CE_POINTER [NATURAL_8]
				a_volume: INTEGER_32
				a_looping: INTEGER_32
				a_tag: INTEGER_32
				a_expire: NATURAL_32
				a_start_time: NATURAL_32
				a_fading: NATURAL_32
				a_fade_volume: INTEGER_32
				a_fade_volume_reset: INTEGER_32
				a_fade_length: NATURAL_32
				a_ticks_fade: NATURAL_32
				a_effects: CE_POINTER [PD_MIX_EFFECTINFO]
			])
		require else
			a_data /= Void
		do
			make
			Current.chunk := a_data.a_chunk
			Current.playing := a_data.a_playing
			Current.paused := a_data.a_paused
			Current.samples := a_data.a_samples
			Current.volume := a_data.a_volume
			Current.looping := a_data.a_looping
			Current.tag := a_data.a_tag
			Current.expire := a_data.a_expire
			Current.start_time := a_data.a_start_time
			Current.fading := a_data.a_fading
			Current.fade_volume := a_data.a_fade_volume
			Current.fade_volume_reset := a_data.a_fade_volume_reset
			Current.fade_length := a_data.a_fade_length
			Current.ticks_fade := a_data.a_ticks_fade
			Current.effects := a_data.a_effects
		end

feature {ANY} -- fields

	chunk: CE_POINTER [PD_MIX_CHUNK] assign set_chunk
		do
			create {CE_CLASS_POINTER [PD_MIX_CHUNK]} Result.make_shared (c__chunk (internal_c_pointer))
		end

	playing: INTEGER_32 assign set_playing
		do
			Result := c__playing (internal_c_pointer)
		end

	paused: INTEGER_32 assign set_paused
		do
			Result := c__paused (internal_c_pointer)
		end

	samples: CE_POINTER [NATURAL_8] assign set_samples
		do
			create {CE_NATURAL_8_POINTER} Result.make_shared (c__samples (internal_c_pointer))
		end

	volume: INTEGER_32 assign set_volume
		do
			Result := c__volume (internal_c_pointer)
		end

	looping: INTEGER_32 assign set_looping
		do
			Result := c__looping (internal_c_pointer)
		end

	tag: INTEGER_32 assign set_tag
		do
			Result := c__tag (internal_c_pointer)
		end

	expire: NATURAL_32 assign set_expire
		do
			Result := c__expire (internal_c_pointer)
		end

	start_time: NATURAL_32 assign set_start_time
		do
			Result := c__start_time (internal_c_pointer)
		end

	fading: NATURAL_32 assign set_fading
		do
			Result := c__fading (internal_c_pointer)
		end

	fade_volume: INTEGER_32 assign set_fade_volume
		do
			Result := c__fade_volume (internal_c_pointer)
		end

	fade_volume_reset: INTEGER_32 assign set_fade_volume_reset
		do
			Result := c__fade_volume_reset (internal_c_pointer)
		end

	fade_length: NATURAL_32 assign set_fade_length
		do
			Result := c__fade_length (internal_c_pointer)
		end

	ticks_fade: NATURAL_32 assign set_ticks_fade
		do
			Result := c__ticks_fade (internal_c_pointer)
		end

	effects: CE_POINTER [PD_MIX_EFFECTINFO] assign set_effects
		do
			create {CE_CLASS_POINTER [PD_MIX_EFFECTINFO]} Result.make_shared (c__effects (internal_c_pointer))
		end

feature {ANY} -- field setters

	set_chunk (a_chunk: CE_POINTER [PD_MIX_CHUNK])
		do
			c__set_chunk (internal_c_pointer, a_chunk.c_pointer)
		end

	set_playing (a_playing: INTEGER_32)
		do
			c__set_playing (internal_c_pointer, a_playing)
		end

	set_paused (a_paused: INTEGER_32)
		do
			c__set_paused (internal_c_pointer, a_paused)
		end

	set_samples (a_samples: CE_POINTER [NATURAL_8])
		do
			c__set_samples (internal_c_pointer, a_samples.c_pointer)
		end

	set_volume (a_volume: INTEGER_32)
		do
			c__set_volume (internal_c_pointer, a_volume)
		end

	set_looping (a_looping: INTEGER_32)
		do
			c__set_looping (internal_c_pointer, a_looping)
		end

	set_tag (a_tag: INTEGER_32)
		do
			c__set_tag (internal_c_pointer, a_tag)
		end

	set_expire (a_expire: NATURAL_32)
		do
			c__set_expire (internal_c_pointer, a_expire)
		end

	set_start_time (a_start_time: NATURAL_32)
		do
			c__set_start_time (internal_c_pointer, a_start_time)
		end

	set_fading (a_fading: NATURAL_32)
		do
			c__set_fading (internal_c_pointer, a_fading)
		end

	set_fade_volume (a_fade_volume: INTEGER_32)
		do
			c__set_fade_volume (internal_c_pointer, a_fade_volume)
		end

	set_fade_volume_reset (a_fade_volume_reset: INTEGER_32)
		do
			c__set_fade_volume_reset (internal_c_pointer, a_fade_volume_reset)
		end

	set_fade_length (a_fade_length: NATURAL_32)
		do
			c__set_fade_length (internal_c_pointer, a_fade_length)
		end

	set_ticks_fade (a_ticks_fade: NATURAL_32)
		do
			c__set_ticks_fade (internal_c_pointer, a_ticks_fade)
		end

	set_effects (a_effects: CE_POINTER [PD_MIX_EFFECTINFO])
		do
			c__set_effects (internal_c_pointer, a_effects.c_pointer)
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return sizeof(struct _Mix_Channel);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return __alignof__(struct _Mix_Channel);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__chunk (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct _Mix_Channel *)$a_c_pointer)->chunk;"
		end

	c__playing (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _Mix_Channel *)$a_c_pointer)->playing;"
		end

	c__paused (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _Mix_Channel *)$a_c_pointer)->paused;"
		end

	c__samples (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct _Mix_Channel *)$a_c_pointer)->samples;"
		end

	c__volume (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _Mix_Channel *)$a_c_pointer)->volume;"
		end

	c__looping (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _Mix_Channel *)$a_c_pointer)->looping;"
		end

	c__tag (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _Mix_Channel *)$a_c_pointer)->tag;"
		end

	c__expire (a_c_pointer: POINTER): NATURAL_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _Mix_Channel *)$a_c_pointer)->expire;"
		end

	c__start_time (a_c_pointer: POINTER): NATURAL_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _Mix_Channel *)$a_c_pointer)->start_time;"
		end

	c__fading (a_c_pointer: POINTER): NATURAL_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _Mix_Channel *)$a_c_pointer)->fading;"
		end

	c__fade_volume (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _Mix_Channel *)$a_c_pointer)->fade_volume;"
		end

	c__fade_volume_reset (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _Mix_Channel *)$a_c_pointer)->fade_volume_reset;"
		end

	c__fade_length (a_c_pointer: POINTER): NATURAL_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _Mix_Channel *)$a_c_pointer)->fade_length;"
		end

	c__ticks_fade (a_c_pointer: POINTER): NATURAL_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct _Mix_Channel *)$a_c_pointer)->ticks_fade;"
		end

	c__effects (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct _Mix_Channel *)$a_c_pointer)->effects;"
		end

	c__set_chunk (a_c_pointer: POINTER; a_chunk: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Mix_Channel *)$a_c_pointer)->chunk = $a_chunk;"
		end

	c__set_playing (a_c_pointer: POINTER; a_playing: INTEGER_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Mix_Channel *)$a_c_pointer)->playing = $a_playing;"
		end

	c__set_paused (a_c_pointer: POINTER; a_paused: INTEGER_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Mix_Channel *)$a_c_pointer)->paused = $a_paused;"
		end

	c__set_samples (a_c_pointer: POINTER; a_samples: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Mix_Channel *)$a_c_pointer)->samples = $a_samples;"
		end

	c__set_volume (a_c_pointer: POINTER; a_volume: INTEGER_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Mix_Channel *)$a_c_pointer)->volume = $a_volume;"
		end

	c__set_looping (a_c_pointer: POINTER; a_looping: INTEGER_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Mix_Channel *)$a_c_pointer)->looping = $a_looping;"
		end

	c__set_tag (a_c_pointer: POINTER; a_tag: INTEGER_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Mix_Channel *)$a_c_pointer)->tag = $a_tag;"
		end

	c__set_expire (a_c_pointer: POINTER; a_expire: NATURAL_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Mix_Channel *)$a_c_pointer)->expire = $a_expire;"
		end

	c__set_start_time (a_c_pointer: POINTER; a_start_time: NATURAL_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Mix_Channel *)$a_c_pointer)->start_time = $a_start_time;"
		end

	c__set_fading (a_c_pointer: POINTER; a_fading: NATURAL_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Mix_Channel *)$a_c_pointer)->fading = $a_fading;"
		end

	c__set_fade_volume (a_c_pointer: POINTER; a_fade_volume: INTEGER_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Mix_Channel *)$a_c_pointer)->fade_volume = $a_fade_volume;"
		end

	c__set_fade_volume_reset (a_c_pointer: POINTER; a_fade_volume_reset: INTEGER_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Mix_Channel *)$a_c_pointer)->fade_volume_reset = $a_fade_volume_reset;"
		end

	c__set_fade_length (a_c_pointer: POINTER; a_fade_length: NATURAL_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Mix_Channel *)$a_c_pointer)->fade_length = $a_fade_length;"
		end

	c__set_ticks_fade (a_c_pointer: POINTER; a_ticks_fade: NATURAL_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Mix_Channel *)$a_c_pointer)->ticks_fade = $a_ticks_fade;"
		end

	c__set_effects (a_c_pointer: POINTER; a_effects: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct _Mix_Channel *)$a_c_pointer)->effects = $a_effects;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "chunk") == 0) return offsetof(struct _Mix_Channel, chunk);
				if(strcmp($a_field_name, "playing") == 0) return offsetof(struct _Mix_Channel, playing);
				if(strcmp($a_field_name, "paused") == 0) return offsetof(struct _Mix_Channel, paused);
				if(strcmp($a_field_name, "samples") == 0) return offsetof(struct _Mix_Channel, samples);
				if(strcmp($a_field_name, "volume") == 0) return offsetof(struct _Mix_Channel, volume);
				if(strcmp($a_field_name, "looping") == 0) return offsetof(struct _Mix_Channel, looping);
				if(strcmp($a_field_name, "tag") == 0) return offsetof(struct _Mix_Channel, tag);
				if(strcmp($a_field_name, "expire") == 0) return offsetof(struct _Mix_Channel, expire);
				if(strcmp($a_field_name, "start_time") == 0) return offsetof(struct _Mix_Channel, start_time);
				if(strcmp($a_field_name, "fading") == 0) return offsetof(struct _Mix_Channel, fading);
				if(strcmp($a_field_name, "fade_volume") == 0) return offsetof(struct _Mix_Channel, fade_volume);
				if(strcmp($a_field_name, "fade_volume_reset") == 0) return offsetof(struct _Mix_Channel, fade_volume_reset);
				if(strcmp($a_field_name, "fade_length") == 0) return offsetof(struct _Mix_Channel, fade_length);
				if(strcmp($a_field_name, "ticks_fade") == 0) return offsetof(struct _Mix_Channel, ticks_fade);
				if(strcmp($a_field_name, "effects") == 0) return offsetof(struct _Mix_Channel, effects);
				fprintf(stderr, "struct _Mix_Channel.%s not found\n", $a_field_name);
				return -1;
			]"
		end

end
