class
	PD_MIX_CHUNK

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			make_initialized,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_allocated: INTEGER_32
				a_abuf: CE_POINTER [NATURAL_8]
				a_alen: NATURAL_32
				a_volume: NATURAL_8
			])
		require else
			a_data /= Void
		do
			make
			Current.allocated := a_data.a_allocated
			Current.abuf := a_data.a_abuf
			Current.alen := a_data.a_alen
			Current.volume := a_data.a_volume
		end

feature {ANY} -- fields

	allocated: INTEGER_32 assign set_allocated
		do
			Result := c__allocated (internal_c_pointer)
		end

	abuf: CE_POINTER [NATURAL_8] assign set_abuf
		do
			create {CE_NATURAL_8_POINTER} Result.make_shared (c__abuf (internal_c_pointer))
		end

	alen: NATURAL_32 assign set_alen
		do
			Result := c__alen (internal_c_pointer)
		end

	volume: NATURAL_8 assign set_volume
		do
			Result := c__volume (internal_c_pointer)
		end

feature {ANY} -- field setters

	set_allocated (a_allocated: INTEGER_32)
		do
			c__set_allocated (internal_c_pointer, a_allocated)
		end

	set_abuf (a_abuf: CE_POINTER [NATURAL_8])
		do
			c__set_abuf (internal_c_pointer, a_abuf.c_pointer)
		end

	set_alen (a_alen: NATURAL_32)
		do
			c__set_alen (internal_c_pointer, a_alen)
		end

	set_volume (a_volume: NATURAL_8)
		do
			c__set_volume (internal_c_pointer, a_volume)
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return sizeof(struct Mix_Chunk);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return __alignof__(struct Mix_Chunk);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__allocated (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct Mix_Chunk *)$a_c_pointer)->allocated;"
		end

	c__abuf (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct Mix_Chunk *)$a_c_pointer)->abuf;"
		end

	c__alen (a_c_pointer: POINTER): NATURAL_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct Mix_Chunk *)$a_c_pointer)->alen;"
		end

	c__volume (a_c_pointer: POINTER): NATURAL_8
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct Mix_Chunk *)$a_c_pointer)->volume;"
		end

	c__set_allocated (a_c_pointer: POINTER; a_allocated: INTEGER_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct Mix_Chunk *)$a_c_pointer)->allocated = $a_allocated;"
		end

	c__set_abuf (a_c_pointer: POINTER; a_abuf: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct Mix_Chunk *)$a_c_pointer)->abuf = $a_abuf;"
		end

	c__set_alen (a_c_pointer: POINTER; a_alen: NATURAL_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct Mix_Chunk *)$a_c_pointer)->alen = $a_alen;"
		end

	c__set_volume (a_c_pointer: POINTER; a_volume: NATURAL_8)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct Mix_Chunk *)$a_c_pointer)->volume = $a_volume;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "allocated") == 0) return offsetof(struct Mix_Chunk, allocated);
				if(strcmp($a_field_name, "abuf") == 0) return offsetof(struct Mix_Chunk, abuf);
				if(strcmp($a_field_name, "alen") == 0) return offsetof(struct Mix_Chunk, alen);
				if(strcmp($a_field_name, "volume") == 0) return offsetof(struct Mix_Chunk, volume);
				fprintf(stderr, "struct Mix_Chunk.%s not found\n", $a_field_name);
				return -1;
			]"
		end

end
