class
	PD_SMPEG_LOADER

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			make_initialized,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_loaded: INTEGER_32
				a_handle: CE_POINTER [ANY]
				a_smpeg_actual_spec: CE_ROUTINE
				a_smpeg_delete: CE_ROUTINE
				a_smpeg_enableaudio: CE_ROUTINE
				a_smpeg_enablevideo: CE_ROUTINE
				a_smpeg_new_rwops: CE_ROUTINE
				a_smpeg_play: CE_ROUTINE
				a_smpeg_play_audio: CE_ROUTINE
				a_smpeg_rewind: CE_ROUTINE
				a_smpeg_setvolume: CE_ROUTINE
				a_smpeg_skip: CE_ROUTINE
				a_smpeg_status: CE_ROUTINE
				a_smpeg_stop: CE_ROUTINE
			])
		require else
			a_data /= Void
		do
			make
			Current.loaded := a_data.a_loaded
			Current.handle := a_data.a_handle
			Current.smpeg_actual_spec := a_data.a_smpeg_actual_spec
			Current.smpeg_delete := a_data.a_smpeg_delete
			Current.smpeg_enableaudio := a_data.a_smpeg_enableaudio
			Current.smpeg_enablevideo := a_data.a_smpeg_enablevideo
			Current.smpeg_new_rwops := a_data.a_smpeg_new_rwops
			Current.smpeg_play := a_data.a_smpeg_play
			Current.smpeg_play_audio := a_data.a_smpeg_play_audio
			Current.smpeg_rewind := a_data.a_smpeg_rewind
			Current.smpeg_setvolume := a_data.a_smpeg_setvolume
			Current.smpeg_skip := a_data.a_smpeg_skip
			Current.smpeg_status := a_data.a_smpeg_status
			Current.smpeg_stop := a_data.a_smpeg_stop
		end

feature {ANY} -- fields

	loaded: INTEGER_32 assign set_loaded
		do
			Result := c__loaded (internal_c_pointer)
		end

	handle: CE_POINTER [ANY] assign set_handle
		do
			create {CE_VOID_POINTER} Result.make_shared (c__handle (internal_c_pointer))
		end

	smpeg_actual_spec: CE_ROUTINE assign set_smpeg_actual_spec
		do
			create Result.make_shared (c__smpeg_actual_spec (internal_c_pointer))
		end

	smpeg_delete: CE_ROUTINE assign set_smpeg_delete
		do
			create Result.make_shared (c__smpeg_delete (internal_c_pointer))
		end

	smpeg_enableaudio: CE_ROUTINE assign set_smpeg_enableaudio
		do
			create Result.make_shared (c__smpeg_enableaudio (internal_c_pointer))
		end

	smpeg_enablevideo: CE_ROUTINE assign set_smpeg_enablevideo
		do
			create Result.make_shared (c__smpeg_enablevideo (internal_c_pointer))
		end

	smpeg_new_rwops: CE_ROUTINE assign set_smpeg_new_rwops
		do
			create Result.make_shared (c__smpeg_new_rwops (internal_c_pointer))
		end

	smpeg_play: CE_ROUTINE assign set_smpeg_play
		do
			create Result.make_shared (c__smpeg_play (internal_c_pointer))
		end

	smpeg_play_audio: CE_ROUTINE assign set_smpeg_play_audio
		do
			create Result.make_shared (c__smpeg_play_audio (internal_c_pointer))
		end

	smpeg_rewind: CE_ROUTINE assign set_smpeg_rewind
		do
			create Result.make_shared (c__smpeg_rewind (internal_c_pointer))
		end

	smpeg_setvolume: CE_ROUTINE assign set_smpeg_setvolume
		do
			create Result.make_shared (c__smpeg_setvolume (internal_c_pointer))
		end

	smpeg_skip: CE_ROUTINE assign set_smpeg_skip
		do
			create Result.make_shared (c__smpeg_skip (internal_c_pointer))
		end

	smpeg_status: CE_ROUTINE assign set_smpeg_status
		do
			create Result.make_shared (c__smpeg_status (internal_c_pointer))
		end

	smpeg_stop: CE_ROUTINE assign set_smpeg_stop
		do
			create Result.make_shared (c__smpeg_stop (internal_c_pointer))
		end

feature {ANY} -- field setters

	set_loaded (a_loaded: INTEGER_32)
		do
			c__set_loaded (internal_c_pointer, a_loaded)
		end

	set_handle (a_handle: CE_POINTER [ANY])
		do
			c__set_handle (internal_c_pointer, a_handle.c_pointer)
		end

	set_smpeg_actual_spec (a_smpeg_actual_spec: CE_ROUTINE)
		do
			c__set_smpeg_actual_spec (internal_c_pointer, a_smpeg_actual_spec.c_pointer)
		end

	set_smpeg_delete (a_smpeg_delete: CE_ROUTINE)
		do
			c__set_smpeg_delete (internal_c_pointer, a_smpeg_delete.c_pointer)
		end

	set_smpeg_enableaudio (a_smpeg_enableaudio: CE_ROUTINE)
		do
			c__set_smpeg_enableaudio (internal_c_pointer, a_smpeg_enableaudio.c_pointer)
		end

	set_smpeg_enablevideo (a_smpeg_enablevideo: CE_ROUTINE)
		do
			c__set_smpeg_enablevideo (internal_c_pointer, a_smpeg_enablevideo.c_pointer)
		end

	set_smpeg_new_rwops (a_smpeg_new_rwops: CE_ROUTINE)
		do
			c__set_smpeg_new_rwops (internal_c_pointer, a_smpeg_new_rwops.c_pointer)
		end

	set_smpeg_play (a_smpeg_play: CE_ROUTINE)
		do
			c__set_smpeg_play (internal_c_pointer, a_smpeg_play.c_pointer)
		end

	set_smpeg_play_audio (a_smpeg_play_audio: CE_ROUTINE)
		do
			c__set_smpeg_play_audio (internal_c_pointer, a_smpeg_play_audio.c_pointer)
		end

	set_smpeg_rewind (a_smpeg_rewind: CE_ROUTINE)
		do
			c__set_smpeg_rewind (internal_c_pointer, a_smpeg_rewind.c_pointer)
		end

	set_smpeg_setvolume (a_smpeg_setvolume: CE_ROUTINE)
		do
			c__set_smpeg_setvolume (internal_c_pointer, a_smpeg_setvolume.c_pointer)
		end

	set_smpeg_skip (a_smpeg_skip: CE_ROUTINE)
		do
			c__set_smpeg_skip (internal_c_pointer, a_smpeg_skip.c_pointer)
		end

	set_smpeg_status (a_smpeg_status: CE_ROUTINE)
		do
			c__set_smpeg_status (internal_c_pointer, a_smpeg_status.c_pointer)
		end

	set_smpeg_stop (a_smpeg_stop: CE_ROUTINE)
		do
			c__set_smpeg_stop (internal_c_pointer, a_smpeg_stop.c_pointer)
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return sizeof(struct __anonstruct_smpeg_loader_53);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return __alignof__(struct __anonstruct_smpeg_loader_53);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__loaded (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct __anonstruct_smpeg_loader_53 *)$a_c_pointer)->loaded;"
		end

	c__handle (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct __anonstruct_smpeg_loader_53 *)$a_c_pointer)->handle;"
		end

	c__smpeg_actual_spec (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct __anonstruct_smpeg_loader_53 *)$a_c_pointer)->SMPEG_actualSpec;"
		end

	c__smpeg_delete (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct __anonstruct_smpeg_loader_53 *)$a_c_pointer)->SMPEG_delete;"
		end

	c__smpeg_enableaudio (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct __anonstruct_smpeg_loader_53 *)$a_c_pointer)->SMPEG_enableaudio;"
		end

	c__smpeg_enablevideo (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct __anonstruct_smpeg_loader_53 *)$a_c_pointer)->SMPEG_enablevideo;"
		end

	c__smpeg_new_rwops (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct __anonstruct_smpeg_loader_53 *)$a_c_pointer)->SMPEG_new_rwops;"
		end

	c__smpeg_play (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct __anonstruct_smpeg_loader_53 *)$a_c_pointer)->SMPEG_play;"
		end

	c__smpeg_play_audio (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct __anonstruct_smpeg_loader_53 *)$a_c_pointer)->SMPEG_playAudio;"
		end

	c__smpeg_rewind (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct __anonstruct_smpeg_loader_53 *)$a_c_pointer)->SMPEG_rewind;"
		end

	c__smpeg_setvolume (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct __anonstruct_smpeg_loader_53 *)$a_c_pointer)->SMPEG_setvolume;"
		end

	c__smpeg_skip (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct __anonstruct_smpeg_loader_53 *)$a_c_pointer)->SMPEG_skip;"
		end

	c__smpeg_status (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct __anonstruct_smpeg_loader_53 *)$a_c_pointer)->SMPEG_status;"
		end

	c__smpeg_stop (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct __anonstruct_smpeg_loader_53 *)$a_c_pointer)->SMPEG_stop;"
		end

	c__set_loaded (a_c_pointer: POINTER; a_loaded: INTEGER_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct __anonstruct_smpeg_loader_53 *)$a_c_pointer)->loaded = $a_loaded;"
		end

	c__set_handle (a_c_pointer: POINTER; a_handle: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct __anonstruct_smpeg_loader_53 *)$a_c_pointer)->handle = $a_handle;"
		end

	c__set_smpeg_actual_spec (a_c_pointer: POINTER; a_smpeg_actual_spec: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct __anonstruct_smpeg_loader_53 *)$a_c_pointer)->SMPEG_actualSpec = $a_smpeg_actual_spec;"
		end

	c__set_smpeg_delete (a_c_pointer: POINTER; a_smpeg_delete: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct __anonstruct_smpeg_loader_53 *)$a_c_pointer)->SMPEG_delete = $a_smpeg_delete;"
		end

	c__set_smpeg_enableaudio (a_c_pointer: POINTER; a_smpeg_enableaudio: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct __anonstruct_smpeg_loader_53 *)$a_c_pointer)->SMPEG_enableaudio = $a_smpeg_enableaudio;"
		end

	c__set_smpeg_enablevideo (a_c_pointer: POINTER; a_smpeg_enablevideo: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct __anonstruct_smpeg_loader_53 *)$a_c_pointer)->SMPEG_enablevideo = $a_smpeg_enablevideo;"
		end

	c__set_smpeg_new_rwops (a_c_pointer: POINTER; a_smpeg_new_rwops: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct __anonstruct_smpeg_loader_53 *)$a_c_pointer)->SMPEG_new_rwops = $a_smpeg_new_rwops;"
		end

	c__set_smpeg_play (a_c_pointer: POINTER; a_smpeg_play: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct __anonstruct_smpeg_loader_53 *)$a_c_pointer)->SMPEG_play = $a_smpeg_play;"
		end

	c__set_smpeg_play_audio (a_c_pointer: POINTER; a_smpeg_play_audio: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct __anonstruct_smpeg_loader_53 *)$a_c_pointer)->SMPEG_playAudio = $a_smpeg_play_audio;"
		end

	c__set_smpeg_rewind (a_c_pointer: POINTER; a_smpeg_rewind: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct __anonstruct_smpeg_loader_53 *)$a_c_pointer)->SMPEG_rewind = $a_smpeg_rewind;"
		end

	c__set_smpeg_setvolume (a_c_pointer: POINTER; a_smpeg_setvolume: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct __anonstruct_smpeg_loader_53 *)$a_c_pointer)->SMPEG_setvolume = $a_smpeg_setvolume;"
		end

	c__set_smpeg_skip (a_c_pointer: POINTER; a_smpeg_skip: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct __anonstruct_smpeg_loader_53 *)$a_c_pointer)->SMPEG_skip = $a_smpeg_skip;"
		end

	c__set_smpeg_status (a_c_pointer: POINTER; a_smpeg_status: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct __anonstruct_smpeg_loader_53 *)$a_c_pointer)->SMPEG_status = $a_smpeg_status;"
		end

	c__set_smpeg_stop (a_c_pointer: POINTER; a_smpeg_stop: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct __anonstruct_smpeg_loader_53 *)$a_c_pointer)->SMPEG_stop = $a_smpeg_stop;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "loaded") == 0) return offsetof(struct __anonstruct_smpeg_loader_53, loaded);
				if(strcmp($a_field_name, "handle") == 0) return offsetof(struct __anonstruct_smpeg_loader_53, handle);
				if(strcmp($a_field_name, "smpeg_actual_spec") == 0) return offsetof(struct __anonstruct_smpeg_loader_53, SMPEG_actualSpec);
				if(strcmp($a_field_name, "smpeg_delete") == 0) return offsetof(struct __anonstruct_smpeg_loader_53, SMPEG_delete);
				if(strcmp($a_field_name, "smpeg_enableaudio") == 0) return offsetof(struct __anonstruct_smpeg_loader_53, SMPEG_enableaudio);
				if(strcmp($a_field_name, "smpeg_enablevideo") == 0) return offsetof(struct __anonstruct_smpeg_loader_53, SMPEG_enablevideo);
				if(strcmp($a_field_name, "smpeg_new_rwops") == 0) return offsetof(struct __anonstruct_smpeg_loader_53, SMPEG_new_rwops);
				if(strcmp($a_field_name, "smpeg_play") == 0) return offsetof(struct __anonstruct_smpeg_loader_53, SMPEG_play);
				if(strcmp($a_field_name, "smpeg_play_audio") == 0) return offsetof(struct __anonstruct_smpeg_loader_53, SMPEG_playAudio);
				if(strcmp($a_field_name, "smpeg_rewind") == 0) return offsetof(struct __anonstruct_smpeg_loader_53, SMPEG_rewind);
				if(strcmp($a_field_name, "smpeg_setvolume") == 0) return offsetof(struct __anonstruct_smpeg_loader_53, SMPEG_setvolume);
				if(strcmp($a_field_name, "smpeg_skip") == 0) return offsetof(struct __anonstruct_smpeg_loader_53, SMPEG_skip);
				if(strcmp($a_field_name, "smpeg_status") == 0) return offsetof(struct __anonstruct_smpeg_loader_53, SMPEG_status);
				if(strcmp($a_field_name, "smpeg_stop") == 0) return offsetof(struct __anonstruct_smpeg_loader_53, SMPEG_stop);
				fprintf(stderr, "struct __anonstruct_smpeg_loader_53.%s not found\n", $a_field_name);
				return -1;
			]"
		end

end
