class
	S_SMPEG_SMPEG_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	smpeg_new_rwops (a_src: CE_POINTER [SD_SDL_RWOPS]; a_info: CE_POINTER [SD_SMPEG_INFO]; a_sdl_audio: INTEGER_32): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared (c_smpeg_new_rwops (a_src.c_pointer, a_info.c_pointer, a_sdl_audio))
		end

	c_smpeg_new_rwops (a_src: POINTER; a_info: POINTER; a_sdl_audio: INTEGER_32): POINTER
		external
			"C inline use <sdl_mixer.h>"
		alias
			"return (EIF_POINTER)SMPEG_new_rwops($a_src, $a_info, $a_sdl_audio);"
		end

	smpeg_enableaudio (a_mpeg: CE_POINTER [ANY]; a_enable: INTEGER_32)
		do
			c_smpeg_enableaudio (a_mpeg.c_pointer, a_enable)
		end

	c_smpeg_enableaudio (a_mpeg: POINTER; a_enable: INTEGER_32)
		external
			"C inline use <sdl_mixer.h>"
		alias
			"SMPEG_enableaudio($a_mpeg, $a_enable);"
		end

	smpeg_enablevideo (a_mpeg: CE_POINTER [ANY]; a_enable: INTEGER_32)
		do
			c_smpeg_enablevideo (a_mpeg.c_pointer, a_enable)
		end

	c_smpeg_enablevideo (a_mpeg: POINTER; a_enable: INTEGER_32)
		external
			"C inline use <sdl_mixer.h>"
		alias
			"SMPEG_enablevideo($a_mpeg, $a_enable);"
		end

	smpeg_delete (a_mpeg: CE_POINTER [ANY])
		do
			c_smpeg_delete (a_mpeg.c_pointer)
		end

	c_smpeg_delete (a_mpeg: POINTER)
		external
			"C inline use <sdl_mixer.h>"
		alias
			"SMPEG_delete($a_mpeg);"
		end

	smpeg_status (a_mpeg: CE_POINTER [ANY]): INTEGER_32
		do
			Result := c_smpeg_status (a_mpeg.c_pointer)
		end

	c_smpeg_status (a_mpeg: POINTER): INTEGER_32
		external
			"C inline use <sdl_mixer.h>"
		alias
			"return SMPEG_status($a_mpeg);"
		end

	smpeg_setvolume (a_mpeg: CE_POINTER [ANY]; a_volume: INTEGER_32)
		do
			c_smpeg_setvolume (a_mpeg.c_pointer, a_volume)
		end

	c_smpeg_setvolume (a_mpeg: POINTER; a_volume: INTEGER_32)
		external
			"C inline use <sdl_mixer.h>"
		alias
			"SMPEG_setvolume($a_mpeg, $a_volume);"
		end

	smpeg_play (a_mpeg: CE_POINTER [ANY])
		do
			c_smpeg_play (a_mpeg.c_pointer)
		end

	c_smpeg_play (a_mpeg: POINTER)
		external
			"C inline use <sdl_mixer.h>"
		alias
			"SMPEG_play($a_mpeg);"
		end

	smpeg_stop (a_mpeg: CE_POINTER [ANY])
		do
			c_smpeg_stop (a_mpeg.c_pointer)
		end

	c_smpeg_stop (a_mpeg: POINTER)
		external
			"C inline use <sdl_mixer.h>"
		alias
			"SMPEG_stop($a_mpeg);"
		end

	smpeg_rewind (a_mpeg: CE_POINTER [ANY])
		do
			c_smpeg_rewind (a_mpeg.c_pointer)
		end

	c_smpeg_rewind (a_mpeg: POINTER)
		external
			"C inline use <sdl_mixer.h>"
		alias
			"SMPEG_rewind($a_mpeg);"
		end

	smpeg_skip (a_mpeg: CE_POINTER [ANY]; a_seconds: REAL_32)
		do
			c_smpeg_skip (a_mpeg.c_pointer, a_seconds)
		end

	c_smpeg_skip (a_mpeg: POINTER; a_seconds: REAL_32)
		external
			"C inline use <sdl_mixer.h>"
		alias
			"SMPEG_skip($a_mpeg, $a_seconds);"
		end

	smpeg_play_audio (a_mpeg: CE_POINTER [ANY]; a_stream: CE_POINTER [NATURAL_8]; a_len: INTEGER_32): INTEGER_32
		do
			Result := c_smpeg_play_audio (a_mpeg.c_pointer, a_stream.c_pointer, a_len)
		end

	c_smpeg_play_audio (a_mpeg: POINTER; a_stream: POINTER; a_len: INTEGER_32): INTEGER_32
		external
			"C inline use <sdl_mixer.h>"
		alias
			"return SMPEG_playAudio($a_mpeg, $a_stream, $a_len);"
		end

	smpeg_actual_spec (a_mpeg: CE_POINTER [ANY]; a_spec: CE_POINTER [SD_SDL_AUDIOSPEC])
		do
			c_smpeg_actual_spec (a_mpeg.c_pointer, a_spec.c_pointer)
		end

	c_smpeg_actual_spec (a_mpeg: POINTER; a_spec: POINTER)
		external
			"C inline use <sdl_mixer.h>"
		alias
			"SMPEG_actualSpec($a_mpeg, $a_spec);"
		end

feature {ANY} -- routine addresses

	smpeg_new_rwops_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent smpeg_new_rwops)
		end

	smpeg_enableaudio_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent smpeg_enableaudio)
		end

	smpeg_enablevideo_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent smpeg_enablevideo)
		end

	smpeg_delete_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent smpeg_delete)
		end

	smpeg_status_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent smpeg_status)
		end

	smpeg_setvolume_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent smpeg_setvolume)
		end

	smpeg_play_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent smpeg_play)
		end

	smpeg_stop_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent smpeg_stop)
		end

	smpeg_rewind_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent smpeg_rewind)
		end

	smpeg_skip_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent smpeg_skip)
		end

	smpeg_play_audio_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent smpeg_play_audio)
		end

	smpeg_actual_spec_address: CE_ROUTINE
		once ("PROCESS")
			create Result.make_agent (agent smpeg_actual_spec)
		end

end
