class
	S_STRING_STATIC

inherit
	CE_UTILITIES

feature {ANY} -- public routines

	memset (a_dst: CE_POINTER [ANY]; a_val: INTEGER_32; a_size: NATURAL_32): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared (c_memset (a_dst.c_pointer, a_val, a_size))
		end

	c_memset (a_dst: POINTER; a_val: INTEGER_32; a_size: NATURAL_32): POINTER
		external
			"C inline use <sdl_mixer.h>"
		alias
			"return (EIF_POINTER)memset($a_dst, $a_val, $a_size);"
		end

	stricmp (a_str1, a_str2: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_stricmp (a_str1.c_pointer, a_str2.c_pointer)
		end

	c_stricmp (a_str1: POINTER; a_str2: POINTER): INTEGER_32
		external
			"C inline use <sdl_mixer.h>"
		alias
			"return _stricmp($a_str1, $a_str2);"
		end

	strnicmp (a_str1, a_str2: CE_POINTER [INTEGER_8]; a_max_count: NATURAL_32): INTEGER_32
		do
			Result := c_strnicmp (a_str1.c_pointer, a_str2.c_pointer, a_max_count)
		end

	c_strnicmp (a_str1: POINTER; a_str2: POINTER; a_max_count: NATURAL_32): INTEGER_32
		external
			"C inline use <sdl_mixer.h>"
		alias
			"return _strnicmp($a_str1, $a_str2, $a_max_count);"
		end

	strncasecmp (a_sz1, a_sz2: CE_POINTER [INTEGER_8]; a_size_max_compare: NATURAL_32): INTEGER_32
		do
			Result := (strnicmp (a_sz1, a_sz2, a_size_max_compare))
		end

	strcasecmp (a_sz1, a_sz2: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := (stricmp (a_sz1, a_sz2))
		end

	memcmp (a_buf1, a_buf2: CE_POINTER [ANY]; a_size: NATURAL_32): INTEGER_32
		do
			Result := c_memcmp (a_buf1.c_pointer, a_buf2.c_pointer, a_size)
		end

	c_memcmp (a_buf1: POINTER; a_buf2: POINTER; a_size: NATURAL_32): INTEGER_32
		external
			"C inline use <sdl_mixer.h>"
		alias
			"return memcmp($a_buf1, $a_buf2, $a_size);"
		end

	memcpy (a_dst, a_src: CE_POINTER [ANY]; a_size: NATURAL_32): CE_POINTER [ANY]
		do
			create {CE_VOID_POINTER} Result.make_shared (c_memcpy (a_dst.c_pointer, a_src.c_pointer, a_size))
		end

	c_memcpy (a_dst: POINTER; a_src: POINTER; a_size: NATURAL_32): POINTER
		external
			"C inline use <sdl_mixer.h>"
		alias
			"return (EIF_POINTER)memcpy($a_dst, $a_src, $a_size);"
		end

	strcpy (a_dest, a_source: CE_POINTER [INTEGER_8]): CE_POINTER [INTEGER_8]
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c_strcpy (a_dest.c_pointer, a_source.c_pointer))
		end

	c_strcpy (a_dest: POINTER; a_source: POINTER): POINTER
		external
			"C inline use <sdl_mixer.h>"
		alias
			"return (EIF_POINTER)strcpy($a_dest, $a_source);"
		end

	strcmp (a_str1, a_str2: CE_POINTER [INTEGER_8]): INTEGER_32
		do
			Result := c_strcmp (a_str1.c_pointer, a_str2.c_pointer)
		end

	c_strcmp (a_str1: POINTER; a_str2: POINTER): INTEGER_32
		external
			"C inline use <sdl_mixer.h>"
		alias
			"return strcmp($a_str1, $a_str2);"
		end

	strlen (a_str: CE_POINTER [INTEGER_8]): NATURAL_32
		do
			Result := c_strlen (a_str.c_pointer)
		end

	c_strlen (a_str: POINTER): NATURAL_32
		external
			"C inline use <sdl_mixer.h>"
		alias
			"return strlen($a_str);"
		end

	strncmp (a_str1, a_str2: CE_POINTER [INTEGER_8]; a_max_count: NATURAL_32): INTEGER_32
		do
			Result := c_strncmp (a_str1.c_pointer, a_str2.c_pointer, a_max_count)
		end

	c_strncmp (a_str1: POINTER; a_str2: POINTER; a_max_count: NATURAL_32): INTEGER_32
		external
			"C inline use <sdl_mixer.h>"
		alias
			"return strncmp($a_str1, $a_str2, $a_max_count);"
		end

	strrchr (a_str: CE_POINTER [INTEGER_8]; a_ch: INTEGER_32): CE_POINTER [INTEGER_8]
		do
			create {CE_INTEGER_8_POINTER} Result.make_shared (c_strrchr (a_str.c_pointer, a_ch))
		end

	c_strrchr (a_str: POINTER; a_ch: INTEGER_32): POINTER
		external
			"C inline use <sdl_mixer.h>"
		alias
			"return (EIF_POINTER)strrchr($a_str, $a_ch);"
		end

end
