class
	SD_BUFFER

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			make_initialized,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_data: CE_POINTER [ANY]
				a_size: INTEGER_32
				a_left: INTEGER_32
			])
		require else
			a_data /= Void
		do
			make
			Current.data := a_data.a_data
			Current.size := a_data.a_size
			Current.left := a_data.a_left
		end

feature {ANY} -- fields

	data: CE_POINTER [ANY] assign set_data
		do
			create {CE_VOID_POINTER} Result.make_shared (c__data (internal_c_pointer))
		end

	size: INTEGER_32 assign set_size
		do
			Result := c__size (internal_c_pointer)
		end

	left: INTEGER_32 assign set_left
		do
			Result := c__left (internal_c_pointer)
		end

feature {ANY} -- field setters

	set_data (a_data: CE_POINTER [ANY])
		do
			c__set_data (internal_c_pointer, a_data.c_pointer)
		end

	set_size (a_size: INTEGER_32)
		do
			c__set_size (internal_c_pointer, a_size)
		end

	set_left (a_left: INTEGER_32)
		do
			c__set_left (internal_c_pointer, a_left)
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return sizeof(struct __anonstruct_buffer_15);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return __alignof__(struct __anonstruct_buffer_15);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__data (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct __anonstruct_buffer_15 *)$a_c_pointer)->data;"
		end

	c__size (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct __anonstruct_buffer_15 *)$a_c_pointer)->size;"
		end

	c__left (a_c_pointer: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return ((struct __anonstruct_buffer_15 *)$a_c_pointer)->left;"
		end

	c__set_data (a_c_pointer: POINTER; a_data: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct __anonstruct_buffer_15 *)$a_c_pointer)->data = $a_data;"
		end

	c__set_size (a_c_pointer: POINTER; a_size: INTEGER_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct __anonstruct_buffer_15 *)$a_c_pointer)->size = $a_size;"
		end

	c__set_left (a_c_pointer: POINTER; a_left: INTEGER_32)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct __anonstruct_buffer_15 *)$a_c_pointer)->left = $a_left;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "data") == 0) return offsetof(struct __anonstruct_buffer_15, data);
				if(strcmp($a_field_name, "size") == 0) return offsetof(struct __anonstruct_buffer_15, size);
				if(strcmp($a_field_name, "left") == 0) return offsetof(struct __anonstruct_buffer_15, left);
				fprintf(stderr, "struct __anonstruct_buffer_15.%s not found\n", $a_field_name);
				return -1;
			]"
		end

end
