class
	SD_MEM

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			make_initialized,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_base: CE_POINTER [NATURAL_8]
				a_here: CE_POINTER [NATURAL_8]
				a_stop: CE_POINTER [NATURAL_8]
			])
		require else
			a_data /= Void
		do
			make
			Current.base := a_data.a_base
			Current.here := a_data.a_here
			Current.stop := a_data.a_stop
		end

feature {ANY} -- fields

	base: CE_POINTER [NATURAL_8] assign set_base
		do
			create {CE_NATURAL_8_POINTER} Result.make_shared (c__base (internal_c_pointer))
		end

	here: CE_POINTER [NATURAL_8] assign set_here
		do
			create {CE_NATURAL_8_POINTER} Result.make_shared (c__here (internal_c_pointer))
		end

	stop: CE_POINTER [NATURAL_8] assign set_stop
		do
			create {CE_NATURAL_8_POINTER} Result.make_shared (c__stop (internal_c_pointer))
		end

feature {ANY} -- field setters

	set_base (a_base: CE_POINTER [NATURAL_8])
		do
			c__set_base (internal_c_pointer, a_base.c_pointer)
		end

	set_here (a_here: CE_POINTER [NATURAL_8])
		do
			c__set_here (internal_c_pointer, a_here.c_pointer)
		end

	set_stop (a_stop: CE_POINTER [NATURAL_8])
		do
			c__set_stop (internal_c_pointer, a_stop.c_pointer)
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return sizeof(struct __anonstruct_mem_17);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return __alignof__(struct __anonstruct_mem_17);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__base (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct __anonstruct_mem_17 *)$a_c_pointer)->base;"
		end

	c__here (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct __anonstruct_mem_17 *)$a_c_pointer)->here;"
		end

	c__stop (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct __anonstruct_mem_17 *)$a_c_pointer)->stop;"
		end

	c__set_base (a_c_pointer: POINTER; a_base: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct __anonstruct_mem_17 *)$a_c_pointer)->base = $a_base;"
		end

	c__set_here (a_c_pointer: POINTER; a_here: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct __anonstruct_mem_17 *)$a_c_pointer)->here = $a_here;"
		end

	c__set_stop (a_c_pointer: POINTER; a_stop: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct __anonstruct_mem_17 *)$a_c_pointer)->stop = $a_stop;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "base") == 0) return offsetof(struct __anonstruct_mem_17, base);
				if(strcmp($a_field_name, "here") == 0) return offsetof(struct __anonstruct_mem_17, here);
				if(strcmp($a_field_name, "stop") == 0) return offsetof(struct __anonstruct_mem_17, stop);
				fprintf(stderr, "struct __anonstruct_mem_17.%s not found\n", $a_field_name);
				return -1;
			]"
		end

end
