class
	SD_UNKNOWN

inherit
	CE_UTILITIES
		redefine
			copy,
			is_equal
		end
	CE_CLASS
		redefine
			make,
			make_shared,
			make_initialized,
			structure_size,
			offset_of,
			copy,
			is_equal
		end

create
	make,
	make_shared,
	make_initialized

feature {NONE}

	make
		do
			internal_c_pointer := internal_c_pointer.memory_alloc (structure_size)
			is_allocated_memory := True
		end

	make_shared (a_c_pointer: POINTER)
		do
			internal_c_pointer := a_c_pointer
		end

	make_initialized (a_data: TUPLE [
				a_data1: CE_POINTER [ANY]
			])
		require else
			a_data /= Void
		do
			make
			Current.data1 := a_data.a_data1
		end

feature {ANY} -- fields

	data1: CE_POINTER [ANY] assign set_data1
		do
			create {CE_VOID_POINTER} Result.make_shared (c__data1 (internal_c_pointer))
		end

feature {ANY} -- field setters

	set_data1 (a_data1: CE_POINTER [ANY])
		do
			c__set_data1 (internal_c_pointer, a_data1.c_pointer)
		end

feature {ANY}

	structure_size: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return sizeof(struct __anonstruct_unknown_18);"
		end

	structure_alignment: INTEGER_32
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return __alignof__(struct __anonstruct_unknown_18);"
		end

	offset_of (a_field_name: STRING_8): INTEGER_32
		local
			l_c_str: C_STRING
		do
			create l_c_str.make (a_field_name)
			Result := c__offset_of (l_c_str.item)
		end

feature {ANY}

	copy (a_other: like Current)
		do
			make
			internal_c_pointer.memory_copy (a_other.c_pointer, structure_size)
		end

	is_equal (a_other: like Current): BOOLEAN
		do
			Result := internal_c_pointer.memory_compare (a_other.c_pointer, structure_size)
		end

feature {NONE}

	structure_info: CE_STRUCTURE
		do
			-- dummy for CE_CLASS invariant
			create Result.make_struct (<<>>)
			Result.alignment := structure_alignment
		end

	c__data1 (a_c_pointer: POINTER): POINTER
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"return (EIF_POINTER)((struct __anonstruct_unknown_18 *)$a_c_pointer)->data1;"
		end

	c__set_data1 (a_c_pointer: POINTER; a_data1: POINTER)
		external
			"C inline use %"sdl_mixer.h%""
		alias
			"((struct __anonstruct_unknown_18 *)$a_c_pointer)->data1 = $a_data1;"
		end

	c__offset_of (a_field_name: POINTER): INTEGER_32
		external
			"C inline use %"sdl_mixer.h%", <string.h>, <stddef.h>, <stdio.h>"
		alias
			"[
				if(strcmp($a_field_name, "data1") == 0) return offsetof(struct __anonstruct_unknown_18, data1);
				fprintf(stderr, "struct __anonstruct_unknown_18.%s not found\n", $a_field_name);
				return -1;
			]"
		end

end
