class
	MUSIC_FILE

inherit
	P_MUSIC_STATIC
	DISPOSABLE

create
	make

feature {NONE}

	make (a_file: STRING_8)
		require
			a_file /= Void and then not a_file.is_empty
		do
			file := a_file
			music := mix_load_mus (ce_string (a_file))
			if music.is_void then
				music := Void
			end
		ensure
			file = a_file
		end

feature {ANY}

	music: CE_POINTER [PD_MIX_MUSIC]

	file: STRING_8

	file_name: STRING_8
		local
			l_index: INTEGER_32
		do
			l_index := file.last_index_of ('/', file.count).max (file.last_index_of ('\', file.count))
			Result := file.substring (l_index + 1, file.count)
		ensure
			Result /= Void and then not Result.is_empty
		end

feature {NONE}

	dispose
		do
			if music /= Void then
				mix_free_music (music)
			end
		end

invariant
	file /= Void and then not file.is_empty
	music = Void or else not music.is_void

end
